Request_Header  STRUC                   ; This is a struct which decribes
	Request_Length  db      ?       ; request block to driver.
	Unit_Number     db      ?
	Command_Number  db      ?
	Completion_Code dw      ?       ; Status on completion.
	Reserved        db      8 DUP(?)
	Total_Of_Units  db      ?
	Driver_Offset   dw      ?       ; Offset and segment of driver's tail.
	Driver_Segment  dw      ?       ;
	Command_Line    dd      ?       ; Command line address.
Request_Header  ENDS

;****************************************************************************
		ORG	0h
Code_Segment    SEGMENT WORD PUBLIC 'CODE'
		ASSUME  cs:Code_Segment, ds:Code_Segment, ss:Code_Segment
Head_Block      PROC    NEAR
		dw      0FFFFh,0FFFFh ; Pointer to a next driver in the train.
Attributes      dw      0C000h                  ; Attributes.
Border          dw      OFFSET Strategy_Block   ; Pointer to strategy block.
Flags           dw      OFFSET Function_Block   ; Pointer to main block.
My_Name         db	'NumL2ESC'		; Driver's name.
Toggle		db	0			; Toggle.
PrevScan	db	0			; Previous scan-code.
;
My_Int10:
	cmp     ax,14FEh		; This is my own code function to check
	jne     Old_Int10		; presence of the driver.
	or	bx,bx			; Function 0 - check presence.
	jnz	Func_1
	mov	bx,WORD PTR cs:[My_Name]
	iret
Func_1:
	mov	cs:[Toggle],bl
	iret
;
Old_Int10:
	db      0EAh
Int10p4 dw	?,?			; Jmp FAR PTR to old INT 10h.
;
comment	%
My_Int16:
	cmp     ah,02h
	je	New_Int16
	cmp     ah,12h
	je	New_Int16
Old_Int16:
	db      0EAh
Int16p1 dw	?,?			; Jmp FAR PTR to old INT 10h.
New_Int16:
	push	ds
	mov	ax,0040h
	mov	ds,ax
	mov	ax,WORD PTR ds:[0017h]
	and	ax,NOT (2000h OR 0020h)
	pop	ds
	iret
%
;
My_Int09:
	pushf
	cmp	cs:[Toggle],1		; Skip interrupt. 
	jne	Skip
	mov	cs:[PrevScan],0		; Clear previous scan-code.
	jmp	SHORT Old_Int09
Skip:
	push	ax			; Save AX.
	push	bx
	in	al,60h			; Get a scan code from kbrd.
	jmp	SHORT $+2		; Delay for I/O.
	mov	bx,ax
;
	cmp	al,45h
	jne	Next
	cmp	cs:[PrevScan],1Dh
	jne	OKey
	jmp	SHORT Quit
Next:
	cmp	al,(80h OR 45h)		; Numlock released ?
	jne	Quit
OKey:
	push	ax
	in	al,61h
	mov	ah,al
	or	al,80h
	out	61h,al
	xchg	al,ah
	out	61h,al
	mov	al,20h
	out	20h,al
;
comment	#
	push	es
	xor	ax,ax
	mov	es,ax
	and	BYTE PTR es:[0417h],NOT 20h	
	pop	es
#
;
	pop	ax
	cmp	al,(80h OR 45h)		; Numlock released ?
	jne	Quit1
;
	push	cx
	mov	ah,5h			; Put it into keyboard buffer.
	mov	cx,011Bh		; ESCAPE.
	int	16h
	pop	cx
Quit1:
	mov	cs:[PrevScan],bl
	pop	bx
	pop	ax
	popf
	iret    
Quit:
	mov	cs:[PrevScan],bl
	pop	bx
	pop	ax
Old_Int09:
	popf
	db	0EAh
Int09p1 dw	?,?			; Jump FAR PTR (old INT 09h).
;-----------------------------------------------------------------------------
Tail:
Save_BX		dw	0
Save_ES		dw	0		; Save these three registers.
;
Strategy_Block:
	mov     cs:[Save_BX],bx		;
	mov     cs:[Save_ES],es         ; Save these three registers.
	retf
;
Function_Block:
	cli                             ; Disable interruptions for a while.
	pushf
	push    ax
	push    bx
	push    cx                      ;
	push    dx                      ;
	push    ds                      ; Save all the registers.
	push    es                      ;
	push    di                      ;
	push    si
	push    bp
;
	mov	ax,14FEh
	xor	bx,bx
	int	10h
	cmp	bx,754Eh		; If I already present...
	jne	Setup
;
	xor	di,di			; Stay no code at all.
	jmp	SHORT Exit
Setup:
	push	cs
	pop	ds
	mov	ax,3509h
	int	21h
	mov	cs:[Int09p1  ],bx
	mov	cs:[Int09p1+2],es
;
	lea	dx,My_Int09
	mov	ax,2509h
	int	21h
;
	mov	ax,3510h
	int	21h
	mov	cs:[Int10p4  ],bx
	mov	cs:[Int10p4+2],es
;
	lea	dx,My_Int10
	mov	ax,2510h
	int	21h
;
comment	%
	mov	ax,3516h
	int	21h
	mov	cs:[Int16p1  ],bx
	mov	cs:[Int16p1+2],es
;
	lea	dx,My_Int16
	mov	ax,2516h
	int	21h
%
;
	lea	di,cs:[Tail]		; Compute tail of the driver.
	mov     cs:[Attributes],8000h   ; Disable any command line for me.
Exit:
	lds	bx,DWORD PTR cs:[Save_BX] ; Load address of request block.
	mov     WORD PTR ds:[bx.Driver_Offset  ],di     ;
	mov     WORD PTR ds:[bx.Driver_Segment ],cs     ;
	mov     WORD PTR ds:[bx.Completion_Code],0100h  ; All done, Master !
	pop     bp
	pop     si
	pop     di                      ;
	pop     es                      ;
	pop     ds                      ; Restore all the registers.
	pop     dx                      ;
	pop     cx                      ;
	pop     bx
	pop     ax
	popf
	sti
	retf
Head_Block      ENDP
Code_Segment    ENDS
		END	Head_Block
